const PREF_SPREAD_FLOCK = 'flock.photo.spreadFlock.include';
const PREF_TAGLINE = 'flock.photo.tagline';
const PREF_PHOTO_DROP_COUNT = 'flock.photo.dropCount';
const PREF_SPREAD_FLOCK_DISABLED = 'flock.photo.spreadFlock.is_disabled'
const SPREAD_FLOCK_STRINGBUNDLE_NAME = 'flock.photo.spread_flock_html';

var photoMagic = {
    timeout: 3000
}

photoMagic.mPhotoAPIManager = Components.classes['@flock.com/photo-api-manager;1?'] 
                                        .getService(Components.interfaces.flockIPhotoAPIManager);
photoMagic.mPhotoPeopleAPIManager = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-people-photo']
                                              .getService(Components.interfaces.flockIPhotoPeopleService);
photoMagic.mPrefSvc = Components.classes['@mozilla.org/preferences-service;1']
                                    .getService(Components.interfaces.nsIPrefBranch);                                    
photoMagic.mStringBundleSvc = Components.classes['@mozilla.org/intl/stringbundle;1']
                                        .getService(Components.interfaces.nsIStringBundleService);
photoMagic.mStringbundle = photoMagic.mStringBundleSvc.createBundle("chrome://browser-region/locale/region.properties");
photoMagic.mSpreadFlockMessage = photoMagic.mStringbundle.GetStringFromName(SPREAD_FLOCK_STRINGBUNDLE_NAME);
                                
photoMagic.onclick = function(obj, event) {
    $('photo-magic-label').value = 'Loading...';
    $('photo-magic').setAttribute('class', 'active')
    if (this.timer) window.clearTimeout( this.timer );

    var service = photoMagic.mPhotoAPIManager.getAPIFromShortname( this.service );
    service.getValidPerson( photoMagic.findListener, this.user );
}

photoMagic.findListener = {
    onGetValidPerson: function(aPerson) {
        photoMagic.mPhotoPeopleAPIManager.addToRecent(aPerson);
        flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster', true);
        TopbarJSCtx().arguments = [aPerson];
        if (TopbarJSCtx().photoBrowser) TopbarJSCtx().photoBrowser.loadPersonPre(aPerson);
        $('photo-magic').setAttribute('class', '')
        photoMagic.hide();
    },
    onError: function(aError) {
        $('photo-magic-label').value = 'Oops: ' + aError.errorString;
        $('photo-magic').setAttribute('class', '')
        this.timer = window.setTimeout( photoMagic.hide, photoMagic.timeout );
    },
}

photoMagic.show = function( obj, service, user ) {
    if ((obj.height <= 75) && (obj.width <= 75)) return;

    if (this.timer) window.clearTimeout( this.timer );
    
    this.service = service;
    this.user = user;

    var scrollTop = obj.ownerDocument.body.scrollTop;
    if (!scrollTop) {
        scrollTop = obj.ownerDocument.documentElement.scrollTop;
    }

    var scrollLeft = obj.ownerDocument.body.scrollLeft;
    if (!scrollLeft) {
        scrollLeft = obj.ownerDocument.documentElement.scrollLeft;
    }

    var top = 0, left = 0;
    var temp=obj;
    while (temp) {
        top += temp.offsetTop;
        left += temp.offsetLeft;
        temp = temp.offsetParent;
    }

    var tabHeight = document.getAnonymousElementByAttribute(gBrowser, "class", "tabbrowser-strip").boxObject.height;

    var view = obj.ownerDocument.defaultView;
    var style = view.getComputedStyle(obj, ""); 

    var borderLeft = (parseInt(style.getPropertyCSSValue('border-left-width').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('margin-left').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('padding-left').cssText) || 0); // XXX - this assumes pixels!
    var borderTop  = (parseInt(style.getPropertyCSSValue('border-top-width').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('margin-top').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('padding-top').cssText) || 0); // XXX - this assumes pixels!

    var pmTop  = top + $('content').boxObject.y + tabHeight + obj.height + borderTop - scrollTop - 24;
    var pmLeft = left + $('content').boxObject.x - scrollLeft + borderLeft;

    if (pmTop + 24 > ($('content').boxObject.y + $('content').boxObject.height)) return;
    
    $('photo-magic').style.top = pmTop + 'px';
    $('photo-magic').style.left = pmLeft  + 'px';
    $('photo-magic-label').value = 'View Photostream';
    $('photo-magic').removeAttribute('hidden');
    this.timer = window.setTimeout( photoMagic.hide, photoMagic.timeout );
}

photoMagic.mouseover = function() {
    if (this.timer) window.clearTimeout( this.timer );
}

photoMagic.mouseout = function() {
    if (this.timer) window.clearTimeout( this.timer );
    this.timer = window.setTimeout( photoMagic.hide, photoMagic.timeout );
}


photoMagic.hide = function() { 
    // XXX - if mouse is over button don't hide but set another for 5 seconds?

    if (this.timer) window.clearTimeout( this.timer );
    this.timer = null;
    $('photo-magic').setAttribute('hidden', true);
}

photoMagic.imager = function(event) {
    if (event.originalTarget.nodeName == 'IMG') {
        for(var i=0;i<photoMagic.mHandlers.length;++i) {
            var handler = photoMagic.mHandlers[i];
            var target = event.originalTarget;
            if(handler.shouldShow(target)) {
                photoMagic.show(target, handler.shortName, handler.url);
				return;
            }
        }
    }
}

/*
var sampleHandler = {
    urlIsFromService: function(aUrl) {
    },
    shouldShow: function(aOriginalTarget) {
    },
    shortName: "flickr",
    url: "http://flickr.com",
}
*/

photoMagic.findServiceForUrl = function(aUrl) {
    for(var i=0;i<photoMagic.mHandlers.length;++i) {
        var handler = photoMagic.mHandlers[i];
        var shortName = handler.urlIsFromService(aUrl);
        if(shortName) {
            return shortName;
        }
    }
    return false;
}

photoMagic.mHandlers = new Array();
photoMagic.registerHandler = function(aHandler) {
    if (photoMagic.mPhotoAPIManager.getAPIFromShortname(aHandler.shortName)) {
        this.mHandlers.push(aHandler);
    }
}

var FlickrMagic = {
    urlIsFromService: function(aUrl) {
        if (aUrl.match(/^https?:\/\/([^\/]*\.)?flickr\.com\/photos\/.+/)) {
            if (aUrl.match(/^https?:\/\/([^\/]*\.)?flickr\.com\/photos\/upload($|\/)/)) return false;
            if (aUrl.match(/^https?:\/\/([^\/]*\.)?flickr\.com\/photos\/organize($|\/)/)) return false;
            if (aUrl.match(/^https?:\/\/([^\/]*\.)?flickr\.com\/photos\/tags($|\/)/)) return false;
            if (aUrl.match(/^https?:\/\/([^\/]*\.)?flickr\.com\/photos\/search($|\/)/)) return false;
            return this.shortName;
        } 
        return false;
    },
    shouldShow: function(aOriginalTarget) {
        var src = aOriginalTarget.src;
        if (src.match('static.flickr.com')) {
            try {
                this.url = aOriginalTarget.parentNode.href;
                if(this.url) return true;
                return false;
            } catch (e) {
                return false;
            }
        }
    },
    shortName: "flickr",
    url: "",
}

var PhotobucketMagic = {
    urlIsFromService: function(aUrl) {
        if(aUrl.match(/^https?:\/\/([^\/]*\.)?photobucket\.com\/albums\/.+/)) return this.shortName;
        return false;
    },
    shouldShow: function(aOriginalTarget) {
        this.url = aOriginalTarget.src;
        if(this.url.match('photobucket.com/albums')) {
            return true;
        }
        this.url = null;
        return false;
    },
    shortName: "photobucket",
    url: "",
}

//note that registration doesn't happen here


// window.addEventListener('tabchange', photoMagic.hide, false);
// window.addEventListener('unload', photoMagic.hide, false); XXX - need to hide on unload 
window.addEventListener('resize', photoMagic.hide, false); // XXX - need to hide on resize

photoMagic.addHTMLtoField = function(aOrigHTML, aTargetElement)
{
  try {
    var spreadFlock = photoMagic.mPrefSvc.getCharPref(PREF_SPREAD_FLOCK);
  } catch (e){};
  var html = aOrigHTML;
    switch (spreadFlock) {
      case 'always':
        html += unescape(photoMagic.mSpreadFlockMessage).replace(/%tagline%/g, photoMagic.mPrefSvc.getCharPref(PREF_TAGLINE)); 
        break;
      case 'ask':
        window.success = false;
        window.openDialog ("chrome://browser/content/flock/photo/spreadFlockAskDlg.xul", "_blank", "modal,close,centerscreen");
        if (window.success)
          html += unescape(photoMagic.mSpreadFlockMessage).replace(/%tagline%/g, photoMagic.mPrefSvc.getCharPref(PREF_TAGLINE)); 
        break;
    }
    aTargetElement.value += html;
}

photoMagic.contentAreaDNDObserver = {
    textareaTarget: null,
    canHandleMultipleItems: true,
    isAPhoto: function (aURL) {
        if (aURL.indexOf("file") != 0) return false;
        var lc = aURL.toLowerCase();
        if (lc.match(/.+jpg$/)) return true;
        if (lc.match(/.+jpeg$/)) return true;
        if (lc.match(/.+png$/)) return true;
        if (lc.match(/.+gif$/)) return true;
        if (lc.match(/.+bmp$/)) return true;
        return false;
    },
    
    onDrop: function (aEvent, aXferData, aDragSession)
    {
        // bail if they're dropping a selection of images
        if (aXferData.dataList.length > 1) return;
        this.textareaTarget = aEvent.target;
        var inst = this;

        aXferData = aXferData.dataList[0].dataList[0];
        
        if (aEvent.target.localName.toLowerCase() == 'textarea') {
            switch (aXferData.flavour.contentType) {
                case "text/photo":
                // We are disabling the "photo commenting by flock" tagline because the feature is half baked
                /*
                    this.html = aXferData.data;
					setTimeout( function() {
					  var count = photoMagic.mPrefSvc.getIntPref(PREF_PHOTO_DROP_COUNT);
					  photoMagic.mPrefSvc.setIntPref(PREF_PHOTO_DROP_COUNT, ++count);
    				  if (!photoMagic.mPrefSvc.getPrefType(PREF_SPREAD_FLOCK_DISABLED)) {
                        photoMagic.mPrefSvc.setBoolPref(PREF_SPREAD_FLOCK_DISABLED, false);
                      }

					  if (!photoMagic.mPrefSvc.getBoolPref(PREF_SPREAD_FLOCK_DISABLED)) {
    					  
                          if (!photoMagic.mPrefSvc.getPrefType(PREF_SPREAD_FLOCK) && count == 3) {
                              window.openDialog('chrome://browser/content/flock/photo/spreadFlockDlg.xul', 
                                                'Spread Flock', 'modal, centerscreen');
                          } 
					  }
					  photoMagic.addHTMLtoField(inst.html, inst.textareaTarget);
				    }, 0);
				    aEvent.preventBubble();
        	        return;
                    break; */
                
                default:
                    var url = transferUtils.retrieveURLFromData(aXferData.data, aXferData.flavour.contentType);
                    if (!url || !url.length || url.indexOf(" ", 0) != -1 || /^\s*(javascript|data):/.test(url)) break;
                    getBrowser().dragDropSecurityCheck(aEvent, aDragSession, url);
                    if (this.isAPhoto(url)) {
                        var photoUploadListener = {
                            onMediaImportStart: function( aFilename, aCount) {
                            
                            },
                            onMediaImportFinish: function( aUpload, aCount ) {
                                flock.photo.util.launchSinglePhotoUpload(aUpload, inst.textareaTarget);
                            },
                            onMediaImportError: function(aFilename) {
                                alert('The photo "' + aFilename + '" could not be uploaded because it is invalid.');
                            },
                        }
                        flock.photouploader.service.importSingleMediaItem(photoUploadListener, url);
	        	        aEvent.preventBubble();
                        return;
                    }
                break;
            }
        }
        contentAreaDNDObserver.onDrop(aEvent, aXferData, aDragSession);
    },
  
    onDragOver: function(aEvent, aFlavour, aDragSession) {
        return contentAreaDNDObserver.onDragOver(aEvent, aFlavour, aDragSession);
    },

    getSupportedFlavours: function() {
        dump('\n\n\ngetSupportedFlavours\n\n\n');
        var flavours = new FlavourSet();
        flavours.appendFlavour("text/photo");
        flavours.appendFlavour("application/x-moz-file","nsIFile");
        flavours.appendFlavour("application/x-moz-url")
        return flavours;
    }

};

photoMagic.mWebProgressListener = {
    onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
    {
    },

    onProgressChange : function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress)
    {
    },

    onLocationChange : function(aWebProgress, aRequest, aLocation)
    {
        photoMagic.hide();
    },

    onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage)
    {
    },

    onSecurityChange : function(aWebProgress, aRequest, aState)
    {
    }
}

photoMagic.dragdrop = function (event) {
    if (event.target.localName.toLowerCase() != 'textarea') {
        // not a textarea
        return false;
    }
    return nsDragAndDrop.drop(event, photoMagic.contentAreaDNDObserver); 
}

photoMagic.dragover = function (event) {
    if (event.target.localName.toLowerCase() != 'textarea') {
        // not a textarea
        return false;
    }
    return nsDragAndDrop.dragOver(event, photoMagic.contentAreaDNDObserver);
}

photoMagic.load = function() {
    gBrowser.addProgressListener(photoMagic.mWebProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    window.addEventListener('mouseover', photoMagic.imager, false);
    window.addEventListener('scroll', photoMagic.hide, false);
}

photoMagic.unload = function() {
    gBrowser.removeProgressListener(photoMagic.mWebProgressListener);
    window.removeEventListener('mouseover', photoMagic.imager, false);
    window.removeEventListener('scroll', photoMagic.hide, false);
}



//shouldn't have to remove these because it is attached to a dom node that is
//destroyed
top.addEventListener('load', photoMagic.load, false); 
top.addEventListener('unload', photoMagic.unload, false); 
