// vim: ts=4 sw=4 cindent expandtab
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var allPhotoSvcs = {};

allPhotoSvcs.mPrefSvc = null;

allPhotoSvcs.load = function() {
    this.mPrefSvc = Components.classes['@mozilla.org/preferences-service;1']
        .getService(Components.interfaces.nsIPrefBranch);
    document.getElementById('additionalPhotoServices').getButton("cancel").hidden = true;
    this.setupList();
}

allPhotoSvcs.setupList = function() {
    var svcs = this.getPhotoServices();
    var listing = document.getElementById('listing');
    
    for (var i=0; i < svcs.length; i++) {
        var account = document.createElement("simplephotoaccount");           
        account.service = svcs[i];
        account.isInstalled = this.isSvcEnabled(account.service.shortName);
        listing.appendChild(account);    
    }
}

allPhotoSvcs.isSvcEnabled = function(aShortname) {
    var prefName = 'flock.photo.service.' + aShortname + '.isDisabled';
    try {
        return (!this.mPrefSvc.getBoolPref(prefName))
    } catch (ex) {
        //dump(ex + '\n');
    }    
    return true;
}

allPhotoSvcs.getPhotoServices = function() {
    var catmgr = Components.classes["@mozilla.org/categorymanager;1"]
          .getService (Components.interfaces.nsICategoryManager);
    var rval = Array();
    var enum = catmgr.enumerateCategory("flockIPhotoAPI");
    while(enum.hasMoreElements()) {
        try {
          var obj = enum.getNext();
          supportsString = obj.QueryInterface(Components.interfaces.nsISupportsCString);
          var shortName = supportsString.toString();
          var cid = catmgr.getCategoryEntry("flockIPhotoAPI", shortName); 
          var svc = Components.classes[cid].getService(Components.interfaces.flockIPhotoAPI);
          rval.push(svc);
        } catch (ex) {
          //debug(ex);
        }
    }
    return rval;
}