//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gBlogPrefCommandController = null;
var gSelectedBlog = null;


function flock_prefBlogLoad() {
    gBlogPrefCommandController = new CommandController();
    gBlogPrefCommandController.cmd_flock_blogPrefAddNotification = flock_blogPrefAddNotificationCommand;
    gBlogPrefCommandController.cmd_flock_blogPrefDelNotification = flock_blogPrefDelNotificationCommand;
    gBlogPrefCommandController.cmd_flock_blogEditAccount = flock_blogEditAccountCommand;
    gBlogPrefCommandController.cmd_flock_blogCreateAccount = flock_blogPrefCreateAccountCommand;
    gBlogPrefCommandController.cmd_flock_blogDeleteAccount = flock_blogDeleteAccountCommand;
    gBlogPrefCommandController.cmd_flock_blogEditAccount = flock_blogEditAccountCommand;

    window.controllers.appendController(gBlogPrefCommandController);

    var ds = flock.blog.settings.ds;

    $("flock-blog-pref-notifications-listbox").database.AddDataSource(ds.getRawDataSource());
    $("flock-blog-pref-notifications-listbox").builder.rebuild();

    // $("flock-blog-pref-openpref").checked = flock_getBoolPref("flock.blog.editInTab");
    $("flock-blog-pref-notify").checked = flock_getBoolPref("flock.blog.notify");

    $("flock-blog-pref-accounts").builder.rebuild();

    // Set the default save folder
    flock.blog.getSaveLocation();
    flock_goUpdateCommandSet($('flock_BlogPrefCommands'));

    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);
}

function flock_blogPrefSelectAccount(aTarget) {
    if(aTarget) {
        gSelectedBlog = FLOCK_BLOG_RDF_SETTINGS  + ":" + aTarget.value;
        window.document.commandDispatcher.updateCommands('select'); 
    }
}

var flock_blogPrefAddNotificationCommand = {
    isEnabled: function() {
        return true;
    },
    exec: function() {
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        var strbundle = document.getElementById("blogStringBundle");
        var input = {value: ""};
        var check = {value: false};
        var title = strbundle.getString("flock.blog.pref.addnotif.title")
        var msg = strbundle.getString("flock.blog.pref.addnotif.msg")
        var result = prompts.prompt(window, title, msg, input, null, check);

        if(result) flock.blog.service.addNotification(input.value);
    },
}

var flock_blogDeleteAccountCommand = {
    isEnabled: function() {
        return gSelectedBlog != null;
    },
    exec: function() {
        var strbundle = document.getElementById("blogStringBundle");
        var msg = strbundle.getString("flock.blog.pref.confirmdelete")
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        if(promptService.confirm(window, strbundle.getString("flock.blog.pref.confirmdelete.title"), msg)) {
            flock.blog.service.deleteAccount(gSelectedBlog);

            gSelectedBlog = null;
            gSelectedBlogIndex = null;
        }
    },
}

var flock_blogPrefCreateAccountCommand = {
    isEnabled: function() {
        return true;
    },
    exec: function() {
        flock_blogOpenWizard();
        $("flock-blog-pref-accounts").builder.rebuild();
        var defaultDir = flock_getCharPref("flock.blog.saveLocation");
    },
}


var flock_blogEditAccountCommand = {
    isEnabled: function() {
        return gSelectedBlog != null;
    },
    exec: function() {
        window.openDialog("chrome://browser/content/flock/blog/blogAccountDlg.xul", "editAccount", "modal", gSelectedBlog); 
    },
}

var flock_blogPrefDelNotificationCommand = {
    isEnabled: function() {
        return true;
        return $("flock-blog-pref-notifications-listbox").selectedItem != null;
    },
    exec: function() {
        var toDelete = $("flock-blog-pref-notifications-listbox").selectedItem.value;
        flock.blog.service.removeNotification(toDelete);
    },
}

function flock_blogPrefOpenPref(obj) {
    flock_setBoolPref("flock.blog.editInTab", obj.checked);
}

function flock_blogPrefNotifyPref(obj) {
    flock_setBoolPref("flock.blog.notify", obj.checked);
}

function chooseSaveFolder()
{
    var strbundle = document.getElementById("blogStringBundle");
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                       .createInstance(Components.interfaces.nsIFilePicker);
    fp.init(window, strbundle.getString("flock.blog.pref.selectFolder")
                       , Components.interfaces.nsIFilePicker.modeGetFolder);
    
    const nsILocalFile = Components.interfaces.nsILocalFile;
    fp.displayDirectory = flock.blog.getSaveLocation();
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);
    if (fp.show() == Components.interfaces.nsIFilePicker.returnOK) {
        flock.blog.setSaveLocation(fp.file);
        var defaultDir = flock_getCharPref("flock.blog.saveLocation");
    }
}
 
